Select case CurrentBuildTarget
case 6, 7, 16, 9, 24
  
  ////////////////////////////////////////////////////////////////////////////////////////////////
  // Xojo build script; created with App Wrapper 3 3.11.4 Beta (400) - ©2022 Ohanaware Co., Ltd.
  // Script built: 25. Mar 2022 @ 15:56:45
  // Script Format: 0013
  // EDITING THIS FILE IS A FUTILE TASK AS APP WRAPPER WILL OVER WRITE IT
  ////////////////////////////////////////////////////////////////////////////////////////////////
  // Set-up the globally required variables
  ////////////////////////////////////////////////////////////////////////////////////////////////
  
  dim appPath as string = currentBuildLocation + "/" + shellEncode( currentBuildAppName )
  if right( appPath, 4 ) <> ".app" then appPath = appPath + ".app"
  if appPath = "/.app" then// - Validate that the script occurs _after_ the Build stage!
    print( "Critical Script Error: Unable to get the path to the built application." + endOfLine + endOfLine + "Please ensure the App Wrapper script is below the 'Build' action in the 'OS X' build settings." )
    
  else
    Dim isDebugBuild as boolean = right( currentBuildAppName, 6 ) = ".debug"
    dim resourcesFolder as string = appPath + "/Contents/Resources/"
    dim plistFile as string = appPath+"/Contents/Info.plist"
    dim plistEntries( -1 ) as string
    
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // When building pass to the App Wrapper Executable
    ////////////////////////////////////////////////////////////////////////////////////////////////
    
    if not isDebugBuild then
      Dim URLPath as string = doShellCommand( "echo """ + appPath + """ | sed 's/ /%20/g;s/!/%21/g;s/""/%22/g;s/#/%23/g;s/\$/%24/g;s/\&/%26/g;s/'\''/%27/g;s/(/%28/g;s/)/%29/g;s/:/%3A/g'" )
      call doShellCommand( "open appwrapper://wrap=" + URLPath )
      return
    end if
    
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // Add the help into the application.
    ////////////////////////////////////////////////////////////////////////////////////////////////
    
    Dim targetHelpFolder as string
    
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // Start macOS Sierra cleaning, a it doesn't like it's own meta data.
    ////////////////////////////////////////////////////////////////////////////////////////////////
    
    call doShellCommand( "xattr -crs " + appPath )
    call doShellCommand( "chmod -RN " + appPath )
    
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // Touching the application in a non-sexual way
    ////////////////////////////////////////////////////////////////////////////////////////////////
    
    call execute( "/usr/bin/touch -acm "+appPath, "Touching the app" )
    
    ////////////////////////////////////////////////////////////////////////////////////////////////
    // --- New codesigning function introduced on Dec 10th, to meet further Apple undocumented changes.
    ////////////////////////////////////////////////////////////////////////////////////////////////
    
    dim result, errors as string
    // --- Codesigning only.
    result = DoShellCommand( "/usr/bin/codesign -f --deep --timestamp=none  -s ""Developer ID Application: Thomas Tempelmann (25856V4B4X)"" " + appPath )
    if result <> "" then print( "Codesigning error" + endOfLine + endOfLine + result )
    
  End if // End Execution Block - after validating the script is in the correct location.
  
Else
  print( "App Wrapper currently only support Mac builds" )
End Select // End Macintosh Specific Block

////////////////////////////////////////////////////////////////////////////////////////////////
// Helper functions used within this script, contents may vary from packaging
////////////////////////////////////////////////////////////////////////////////////////////////

Function execute( inCommand as string, inMethodName as string ) as boolean
  Dim result as string = DoShellCommand( inCommand )
  if result <> "" then
    print( "An error occurred while "+inMethodName + endOfLine + endOfLine + "Message: "+result )
    return false
  else
    return true
  end if
End Function
Function shellEncode( inValue as string ) as string
  Dim rvalue as string = replaceAll( inValue, " ", "\ " )
  rvalue = replaceAll( rvalue, "&", "\&" )
  rvalue = replaceAll( rvalue, "-", "\-" )
  rvalue = replaceAll( rvalue, "(", "\(" )
  rvalue = replaceAll( rvalue, ")", "\)" )
  return rvalue
End Function
Sub msgBox( inMessage as string, inSecondLine as string = "" )
  call showDialog( inMessage, inSecondLine, "OK", "", "", 0 )
End Sub
Function copyFile( inSource as string, inTarget as string, inMethodName as string ) as boolean
  return execute( "/bin/cp -fR "+inSource+" "+inTarget, inMethodName )
End Function
Function readValue( plistFile as string, key as string ) as string
  return trim( DoShellCommand( "/usr/bin/defaults read "+plistfile+" "+key ) )
End Function
Function writeValue( plistFile as string, value as string ) as boolean
  return execute( "/usr/bin/defaults write "+plistFile+" " + value, "Adding "+value+" to the info.plist file." )
End Function
Function deleteValue( plistFile as string, key as string ) as boolean
  return execute( "/usr/bin/defaults delete "+plistFile+" "+key, "Deleting "+key+" from info.plist file." )
End Function